VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cThread"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Sub BindArray Lib "kernel32" Alias "RtlMoveMemory" (PArr() As Any, ByVal pSrc&, Optional ByVal CB& = 4)
Private Declare Sub ReleaseArray Lib "kernel32" Alias "RtlMoveMemory" (PArr() As Any, Optional pSrc& = 0, Optional ByVal CB& = 4)

Private Type ThreadInitDirectCOM
  Param As Long 'User-Param (given into the ThreadMain-Method of the COM-Dll)
  hThread As Long 'filled from Thread (instantly, after STARTCOMOBJECT() returns)
  ThreadID As Long 'filled from Thread (if fully initialized, some msec after STARTCOMOBJECT())
  Reserved(0 To 127) As Long
  FPS As Long
  CancelThread As Boolean
End Type

Private TI() As ThreadInitDirectCOM

Public Function ThreadMain(ByVal Param As Long) As Long
  BindArray TI, Param 'span TI virtually over the same Memory as occupied by the TI-Array which was allocated in the Main-Threads ThreadWrapper-Class
    Set fThread.Thread = Me 'hand a reference of this Class-Instance over into the Thread-Form too
        fThread.Caption = "ThreadID: " & App.ThreadID 'update the ThreadForms Caption with the ThreadID of this Thread
        fThread.Show vbModal 'show the ThreadForm modally
    Set fThread.Thread = Nothing
  ReleaseArray TI 'avoid double-freeing (since the TI-Array is already freed in the MainThreads ThreadWrapper-Instance)
End Function

Friend Property Let FPS(ByVal FPS As Long) 'a Let-Property for the Write-Direction (Information, updated from this Thread here)
  TI(0).FPS = FPS 'update the shared-memory Array-Member (to give an example, how we can transport Info from here into the Main-Thread)
End Property

Friend Property Get Cancelled() As Boolean 'a Get-Property for the Read-Direction on the Shared-Memory-Array (reading a member which is updated from the Main-Thread)
  Cancelled = TI(0).CancelThread 'so, here's the opposite to FPS (we access the CancelThread-Member, to detect when the Main-Thread wants us to close)
End Property

