VERSION 5.00
Begin VB.Form fThread 
   Caption         =   "Form1"
   ClientHeight    =   4935
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   7065
   LinkTopic       =   "Form1"
   ScaleHeight     =   329
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   471
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   240
      Top             =   240
   End
End
Attribute VB_Name = "fThread"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function StretchDIBits& Lib "gdi32" (ByVal hDC&, ByVal x&, ByVal y&, ByVal dx&, ByVal dy&, ByVal SrcX&, ByVal SrcY&, ByVal Srcdx&, ByVal Srcdy&, lpBits As Any, lpBitsInfo As Any, ByVal wUsage&, ByVal dwRop&)

Const PxlWidth& = 320, PxlHeight& = 240

Private Colors(0 To 255) As Long, Pxls&(0 To PxlWidth * PxlHeight - 1), FPS&

Public Thread As cThread

Private Sub Form_Activate()
  FillColorTable
  Do 'enter the Render-Loop (the Form does nothing else)
    DoPlasma
    FPS = FPS + 1
    DoEvents 'give the Timer some breathing-space, to update the FPS
  Loop Until FPS < 0 Or Thread.Cancelled
  If Thread.Cancelled Then Unload Me 'react to outside cancelling
End Sub

Private Sub Timer1_Timer()
  Thread.FPS = FPS: FPS = 0
End Sub
 
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  FPS = -1 'just to make sure, we exit the Render-Loop too
End Sub

'the following are only the helper-functions for drawing the Plasma-Effect onto the Form.hDC
Private Sub FillColorTable()
  Dim i As Long, R As Byte, G As Byte
  For i = 0 To 255
    R = 255 - (Sin(3.14 * 2 * i / 255) + 1) * 127
    G = (Sin(3.14 * 2 * i / 127) + 1) * 64
    Colors(i) = RGB(R, G, 255 - R)
  Next
End Sub
Private Sub DoPlasma()
Dim i&, x&, y&, c1#, c2#, c3#
Static f&, sn2#(0 To PxlWidth), cs2#(0 To PxlHeight)

  For x = 0 To PxlWidth - 1
    sn2(x) = Sin(0.008 * f) * 160 + 159 - x
    sn2(x) = sn2(x) * sn2(x)
  Next
  For y = 0 To PxlHeight - 1
    cs2(y) = Cos(0.012 * f) * 120 + 119 - y
    cs2(y) = cs2(y) * cs2(y)
  Next
  
  For y = 0 To PxlHeight - 1: For x = 0 To PxlWidth - 1
    c1 = Sin(f * 0.01 + x * 0.02 + y * 0.005)
    c2 = Sin(Sqr(sn2(x) + cs2(y)) * 0.02)
    Pxls(i) = Colors((c1 + c2) * 64 + 127.5): i = i + 1
  Next x, y
  
  DrawArr Pxls, hDC, PxlWidth, PxlHeight, ScaleWidth, ScaleHeight
  f = f + 1
End Sub
Private Sub DrawArr(P&(), DC&, dx&, dy&, Optional ByVal dxDst&, Optional ByVal dyDst&)
Dim BI&(9), W&, H&
  W = dx: If dxDst <= 0 Then dxDst = W
  H = dy: If dyDst <= 0 Then dyDst = H
  BI(0) = 40: BI(1) = W: BI(2) = -H: BI(3) = 1 + 65536 * 32 '32bpp
  StretchDIBits DC, 0, 0, dxDst, dyDst, 0, 0, W, H, P(0), BI(0), 0, vbSrcCopy
End Sub


